using System.Drawing;
using Infragistics.Documents.Excel;
using Infragistics.Win.UltraWinGrid.ExcelExport;
using com.airbus.pm00.model;
using Excel;
using Office;
using System.Windows.Forms;

namespace com.airbus.pm00.controller
{
	public class CtrlExcelExportFleetCard
	{
		private static CtrlExcelExportFleetCard _CtrlExcelExportFleetCard_Singleton = null;

		private int nbColumnsMscn = 0;
		private bool actionLineMscn = false;
		private int nbActionsMscn = 0;

		private string PreviousLineType = "";

		private int rememberCurrentRowMscn = 0;

		public int lastMscnColumn = 0;
		public int lastMscnRow = 0;

		public CtrlExcelExportFleetCard()
		{
		}

		public static CtrlExcelExportFleetCard GetInstance()
		{
			//creer une nouvelle instance s il n'en existe pas deja une autre
			if(_CtrlExcelExportFleetCard_Singleton == null) _CtrlExcelExportFleetCard_Singleton = new CtrlExcelExportFleetCard();
			return _CtrlExcelExportFleetCard_Singleton;
		}

		public void BeginExport(BeginExportEventArgs e)
		{
			nbColumnsMscn = 0;
			nbActionsMscn = 0;

			rememberCurrentRowMscn = 0;
			lastMscnColumn = 0;
			lastMscnRow = 0;

			PreviousLineType = "Title";
		}

		public void FillCellTitle(Infragistics.Documents.Excel.Worksheet worksheet, int rowIndex, int columnOffset, string cellValue, ExcelDefaultableBoolean boldValue)
		{
			worksheet.Rows[rowIndex].Cells[columnOffset].Value = cellValue;
			worksheet.Rows[rowIndex].Cells[columnOffset].CellFormat.Font.Bold = boldValue;
			worksheet.Rows[rowIndex].Cells[columnOffset].CellFormat.VerticalAlignment = VerticalCellAlignment.Top;
		}

		public void FillCellValue(Infragistics.Documents.Excel.Worksheet worksheet, int rowIndex, int columnOffset, string cellValue)
		{
			worksheet.Rows[rowIndex].Cells[columnOffset].Value = cellValue;
            worksheet.Rows[rowIndex].Cells[columnOffset].CellFormat.TopBorderColor = System.Drawing.Color.FromArgb(((byte)(255)), ((byte)(0)), ((byte)(0)), ((byte)(0)));//Color.Black;
			worksheet.Rows[rowIndex].Cells[columnOffset].CellFormat.RightBorderColor = Color.Black;
			worksheet.Rows[rowIndex].Cells[columnOffset].CellFormat.BottomBorderColor = Color.Black;
			worksheet.Rows[rowIndex].Cells[columnOffset].CellFormat.LeftBorderColor = Color.Black;
			worksheet.Rows[rowIndex].Cells[columnOffset].CellFormat. FillPattern = FillPatternStyle.Default;
			worksheet.Rows[rowIndex].Cells[columnOffset].CellFormat.FillPatternBackgroundColor = System.Drawing.Color.FromArgb(((byte)(255)), ((byte)(192)), ((byte)(128)));
			worksheet.Rows[rowIndex].Cells[columnOffset].CellFormat.FillPatternForegroundColor = System.Drawing.Color.FromArgb(((byte)(255)), ((byte)(192)), ((byte)(128)));
			worksheet.Rows[rowIndex].Cells[columnOffset].CellFormat.WrapText = ExcelDefaultableBoolean.True;
			worksheet.Rows[rowIndex].Cells[columnOffset].CellFormat.VerticalAlignment = VerticalCellAlignment.Top;
		}

		public void FillCellComment(Infragistics.Documents.Excel.Worksheet worksheet, int rowIndex, int columnOffset, string cellValue)
		{
			worksheet.Rows[rowIndex].Cells[columnOffset].Value = cellValue;
			worksheet.Rows[rowIndex].Cells[columnOffset].CellFormat.WrapText = ExcelDefaultableBoolean.True;
			worksheet.Rows[rowIndex].Cells[columnOffset].CellFormat.VerticalAlignment = VerticalCellAlignment.Top;
		}

		public void FillCellSimple (Infragistics.Documents.Excel.Worksheet worksheet, int rowIndex, int columnOffset, string cellValue)
		{
			worksheet.Rows[rowIndex].Cells[columnOffset].Value = cellValue;
		}

		public void FillCellRounded (Infragistics.Documents.Excel.Worksheet worksheet, int rowIndex, int columnOffset, string cellValue)
		{
			worksheet.Rows[rowIndex].Cells[columnOffset].CellFormat.TopBorderColor = Color.Black;
			worksheet.Rows[rowIndex].Cells[columnOffset].CellFormat.RightBorderColor = Color.Black;
			worksheet.Rows[rowIndex].Cells[columnOffset].CellFormat.BottomBorderColor = Color.Black;
			worksheet.Rows[rowIndex].Cells[columnOffset].CellFormat.LeftBorderColor = Color.Black;
		}

		public void HeaderRowExporting(HeaderRowExportingEventArgs e, int rowOffset)
		{
			if (e.Band.Columns.Exists("C_ACTION_ID"))
			{
				rememberCurrentRowMscn = e.CurrentRowIndex-2;
				e.CurrentColumnIndex = nbColumnsMscn+1;
				e.CurrentRowIndex = rowOffset;
			}
		}

		public void HeaderRowExported(HeaderRowExportedEventArgs e)
		{
			if (e.Band.Columns.Exists("C_ACTION_ID")) e.CurrentRowIndex = rememberCurrentRowMscn;
		}

		public void CellExporting(CellExportingEventArgs e)
		{         
			if (e.GridColumn.Key == "TitleValue")
			e.CurrentColumnIndex = e.CurrentColumnIndex + 1;
			e.CurrentWorksheet.Rows[e.CurrentRowIndex].Cells[e.CurrentColumnIndex].CellFormat.WrapText = ExcelDefaultableBoolean.True;
		}

		public void CellExported(CellExportedEventArgs e)
		{
			if (e.GridColumn.Key == "TitleName")
			{
                e.CurrentWorksheet.Rows[e.CurrentRowIndex].Cells[e.CurrentColumnIndex - 1].Value = e.CurrentWorksheet.Rows[e.CurrentRowIndex].Cells[e.CurrentColumnIndex].Value;
                e.CurrentWorksheet.Rows[e.CurrentRowIndex].Cells[e.CurrentColumnIndex].Value = "";
                e.CurrentWorksheet.Rows[e.CurrentRowIndex].Cells[e.CurrentColumnIndex - 1].CellFormat.TopBorderColor = Color.Black;
                e.CurrentWorksheet.Rows[e.CurrentRowIndex].Cells[e.CurrentColumnIndex - 1].CellFormat.RightBorderColor = Color.Black;
                e.CurrentWorksheet.Rows[e.CurrentRowIndex].Cells[e.CurrentColumnIndex - 1].CellFormat.BottomBorderColor = Color.Black;
                e.CurrentWorksheet.Rows[e.CurrentRowIndex].Cells[e.CurrentColumnIndex - 1].CellFormat.LeftBorderColor = Color.Black;
                e.CurrentWorksheet.Rows[e.CurrentRowIndex].Cells[e.CurrentColumnIndex - 1].CellFormat.FillPattern = FillPatternStyle.Default;
                e.CurrentWorksheet.Rows[e.CurrentRowIndex].Cells[e.CurrentColumnIndex - 1].CellFormat.FillPatternBackgroundColor = System.Drawing.Color.FromArgb(((byte)(113)), ((byte)(138)), ((byte)(195)));
                e.CurrentWorksheet.Rows[e.CurrentRowIndex].Cells[e.CurrentColumnIndex - 1].CellFormat.FillPatternForegroundColor = System.Drawing.Color.FromArgb(((byte)(113)), ((byte)(138)), ((byte)(195)));
                e.CurrentWorksheet.Rows[e.CurrentRowIndex].Cells[e.CurrentColumnIndex - 1].CellFormat.Font.Color = Color.White;
                e.CurrentWorksheet.Rows[e.CurrentRowIndex].Cells[e.CurrentColumnIndex - 1].CellFormat.WrapText = ExcelDefaultableBoolean.True;
            }
			if (e.GridColumn.Key == "PropertyName")
			{
				e.CurrentWorksheet.Rows[e.CurrentRowIndex].Cells[e.CurrentColumnIndex].CellFormat.WrapText = ExcelDefaultableBoolean.True;
			}
		}


		public void RowExporting(RowExportingEventArgs e, int columnOffset)
		{
			if ((e.GridRow.Band.Columns.Exists("PropertyValue")) && (PreviousLineType == "Title"))
			{
				e.CurrentRowIndex = e.CurrentRowIndex - 1;
				PreviousLineType = "Property";
			} 
            else if (e.GridRow.Band.Columns.Exists("TitleValue"))
			{
				e.CurrentColumnIndex = e.CurrentColumnIndex + 1;
				if (PreviousLineType == "Property")
				{
					e.CurrentRowIndex = e.CurrentRowIndex - 1;
					PreviousLineType = "Title";
				}
        	}
		}

		public void HeaderCellExported(HeaderCellExportedEventArgs e)
		{
			if (e.CurrentColumnIndex > lastMscnColumn) lastMscnColumn = e.CurrentColumnIndex;
			if (!e.GridRow.Band.Columns.Exists("C_ACTION_ID")) nbColumnsMscn = e.CurrentColumnIndex;
		}


		public void EndExport(EndExportEventArgs e, int rowOffset, int columnOffset)
		{
			lastMscnRow = e.CurrentRowIndex;
			if (actionLineMscn)
			{
				MergeActions(e.CurrentWorksheet, e.CurrentRowIndex, columnOffset, nbActionsMscn, nbColumnsMscn);
				nbActionsMscn = 0;
				actionLineMscn = false;
			}
			for(int iRow=rowOffset; iRow<=e.CurrentRowIndex; iRow++)
			{
                //e.CurrentWorksheet.Rows[iRow].Expanded = true;//Deprecated
                e.CurrentWorksheet.Rows[iRow].Hidden = false;
				e.CurrentWorksheet.Rows[iRow].OutlineLevel = 0;
			}
		}
        
		private void MergeActions(Infragistics.Documents.Excel.Worksheet worksheet, int rowIndex, int columnOffset, int nbActions, int nbColumns)
		{
			//Merge Columns
			int firstRowToMerge = rowIndex-nbActions;
			int lastRowToMerge = rowIndex-1;
			//Do not merge * cells
			for (int iColumn = columnOffset+1; iColumn<=nbColumns; iColumn++)
			{
				worksheet.MergedCellsRegions.Add(firstRowToMerge, iColumn, lastRowToMerge, iColumn);
			}
			for (int iColumn = 1; iColumn<=6; iColumn++)
			{
				worksheet.Rows[lastRowToMerge].Cells[nbColumns+iColumn].CellFormat.BottomBorderColor = Color.Black;
			}
			//recopier la valeur de l'* sur toutes les lignes
			int starColumn = columnOffset;
			for (int iRow = firstRowToMerge+1; iRow<=lastRowToMerge; iRow++)
			{
				worksheet.Rows[iRow].Cells[starColumn].Value = worksheet.Rows[firstRowToMerge].Cells[starColumn].Value;
				worksheet.Rows[iRow].Cells[starColumn].CellFormat.SetFormatting(worksheet.Rows[firstRowToMerge].Cells[starColumn].CellFormat);
				worksheet.Rows[iRow].Cells[starColumn].CellFormat.TopBorderStyle = CellBorderLineStyle.Thin;
				worksheet.Rows[iRow].Cells[starColumn].CellFormat.TopBorderColor = Color.LightGray;
			}
		}
	}
}
