using System.Collections;
using System.Drawing;
using Infragistics.Documents.Excel;
using Infragistics.Win.UltraWinGrid.ExcelExport;
using com.airbus.pm00.model;
using com.airbus.pm00.controller.util;
using System.IO;
using System.Xml;
using Infragistics.Win.UltraWinGrid;

namespace com.airbus.pm00.controller
{
    public class CtrlExcelExportMilestone
    {
        private static CtrlExcelExportMilestone _CtrlExcelExportMilestone_Singleton = null;

        public int nbColumnsMilestones = 0;
        private bool actionLine = false;
        private int nbActions = 0;
        private int rememberCurrentRow = 0;
        private ArrayList csList = new ArrayList();
        private string currentMsn;
        private int nbColumnsAction = 0;

        public int lastMilestoneRow = 0;

        //code for adding link column in export by Koshlendra on 21/06/2013 start
        public int lastMilestoneColumn = 0;
        public ArrayList linksList = new ArrayList();
        private int nbColumnsLink = 0;
        private int linkHeaderLine = 0;
        private int rememberCurrentRowLink = 0;
        private bool linkLine = false;
        //code for adding link column in export by Koshlendra on 21/06/2013 End

        //code added by seema to add merged header on temp columns in Excel Report on 17th June 2013 starts
        private int tempColCount = 0;
        private int nbofvisibleTEmpcount = 0;
        //code added by seema to add merged header on temp columns in Excel Report on 17th June 2013 ends



        public CtrlExcelExportMilestone()
        {
        }

        public static CtrlExcelExportMilestone GetInstance()
        {
            //creer une nouvelle instance s il n'en existe pas deja une autre
            if (_CtrlExcelExportMilestone_Singleton == null) _CtrlExcelExportMilestone_Singleton = new CtrlExcelExportMilestone();
            return _CtrlExcelExportMilestone_Singleton;
        }

        public void BeginExport(BeginExportEventArgs e)
        {
            nbColumnsMilestones = 0;
            actionLine = false;
            nbActions = 0;
            rememberCurrentRow = 0;
            csList.Clear();
            currentMsn = "";
            lastMilestoneRow = 0;
            nbColumnsAction = 0;
            //change made by seema to add temp col header in excel export on 17th june 2013 starts
            tempColCount = 0;
            nbofvisibleTEmpcount = 0;
            //change made by seema to add temp col header in excel export on 17th june 2013 ends 

            //code for adding link column in export by Koshlendra on 21/06/2013 start
            lastMilestoneColumn = 0;
            linksList.Clear();
            nbColumnsLink = 0;
            linkHeaderLine = 0;
            rememberCurrentRowLink = 0;
            linkLine = false;
            //code for adding link column in export by Koshlendra on 21/06/2013 End

            foreach (UltraGridColumn col in CtrlMain.GetInstance().UiM.UgrMilestones.DisplayLayout.Bands[BusMilestonesDates.CNameRelMilestonesActions].Columns)
            {
                if (col.IsVisibleInLayout) nbColumnsAction++;
            }
            foreach (UltraGridColumn col in CtrlMain.GetInstance().UiM.UgrMilestones.DisplayLayout.Bands[BusMilestonesDates.CNameMonitoredMilestones].Columns)
            {
                if (col.Tag != null)
                {
                    if (col.Tag.ToString().Contains("TEMP_COL"))
                    {
                        if (col.IsVisibleInLayout) nbofvisibleTEmpcount++;
                    }
                }
            }
        }
        //code for adding link column in export by Koshlendra on 21/06/2013 start
        //public void HeaderRowExporting(HeaderRowExportingEventArgs e, int rowOffset)
        public void HeaderRowExporting(HeaderRowExportingEventArgs e, int rowOffset, int columnOffset)
        {
            if (e.Band.Columns.Exists("C_ACTION_ID"))
            {
                UltraGridBand parentBand = e.Band.ParentBand;
                if (parentBand.Key == BusMilestonesDates.CNameMonitoredMilestones)
                {
                    rememberCurrentRow = e.CurrentRowIndex - 2;
                    e.CurrentColumnIndex = nbColumnsMilestones + 1;
                    e.CurrentRowIndex = rowOffset;
                }
                else if (parentBand.Key == BusMilestonesDates.CNameRelMilestonesLinks)
                {
                    rememberCurrentRowLink = e.CurrentRowIndex - 2;
                    e.CurrentColumnIndex = nbColumnsLink + 1;
                    e.CurrentRowIndex = linkHeaderLine;
                }
            }
            else if (e.Band.Key == BusMilestonesDates.CNameRelMilestonesLinks)
            {
                e.CurrentRowIndex = e.CurrentRowIndex - 1;
                if (actionLine)
                {
                    MergeActions(e.CurrentWorksheet, e.CurrentRowIndex, columnOffset, nbActions, nbColumnsMilestones);
                    nbActions = 0;
                    actionLine = false;
                }
                linkHeaderLine = e.CurrentRowIndex;
                //e.CurrentWorksheet.Rows[e.CurrentRowIndex].Cells[columnToIdentifyOutPointOrLink].Value = "L";
            }
        }
        //code for adding link column in export by Koshlendra on 21/06/2013 End

        public void HeaderRowExported(HeaderRowExportedEventArgs e)
        {
            //code for adding link column in export by Koshlendra on 21/06/2013 start
            //if (e.Band.Columns.Exists("C_ACTION_ID")) e.CurrentRowIndex = rememberCurrentRow;

            UltraGridBand parentBand = e.Band.ParentBand;
            if (e.Band.Columns.Exists("C_ACTION_ID"))
            {
                if (parentBand.Key == BusMilestonesDates.CNameMonitoredMilestones)
                {
                    e.CurrentRowIndex = rememberCurrentRow;
                }
                else if (parentBand.Key == BusMilestonesDates.CNameRelMilestonesLinks)
                {
                    e.CurrentRowIndex = rememberCurrentRowLink;
                }
            }

            //code for adding link column in export by Koshlendra on 21/06/2013 End
        }

        public void RowExporting(RowExportingEventArgs e, int columnOffset)
        {
            if (e.GridRow.Band.Columns.Exists("C_ACTION_ID"))
            {
                //code for adding link column in export by Koshlendra on 21/06/2013 Start
                UltraGridBand parentBand = e.GridRow.Band.ParentBand;
                if (parentBand.Key == BusMilestonesDates.CNameMonitoredMilestones)
                {

                    e.CurrentColumnIndex = nbColumnsMilestones + 1;
                    nbActions = nbActions + 1;
                    actionLine = true;
                }
                else if (parentBand.Key == BusMilestonesDates.CNameRelMilestonesLinks)
                {
                    //band rfc action
                    e.CurrentColumnIndex = nbColumnsLink + 1;
                    //e.CurrentWorksheet.Rows[e.CurrentRowIndex].Cells[columnToIdentifyOutPointOrLink].Value = "L";
                }
                //code for adding link column in export by Koshlendra on 21/06/2013 End
            }
            else if (actionLine)
            {
                e.CurrentRowIndex = e.CurrentRowIndex - 1;
                //if (nbActions > 1) MergeActions(e.CurrentWorksheet, e.CurrentRowIndex, columnOffset, nbActions, nbColumnsMilestones);
                MergeActions(e.CurrentWorksheet, e.CurrentRowIndex, columnOffset, nbActions, nbColumnsMilestones);
                nbActions = 0;
                actionLine = false;
            }

            //code for adding link column in export by Koshlendra on 21/06/2013 Start
            if (e.GridRow.Band.Key == BusMilestonesDates.CNameMonitoredMilestones && linkLine)
                e.CurrentRowIndex = e.CurrentRowIndex - 1;
            if (e.GridRow.Band.Key == BusMilestonesDates.CNameRelMilestonesLinks)
                linkLine = true;
            else linkLine = false;
            //code for adding link column in export by Koshlendra on 21/06/2013 End

        }

        public void RowExported(RowExportedEventArgs e)
        {
            e.CurrentWorksheet.Rows[e.CurrentRowIndex].OutlineLevel = 0;
        }

        public void HeaderCellExporting(HeaderCellExportingEventArgs e)
        {
            // if (e.GridHeader.Column.Key.EndsWith("Cs"))
            foreach (UltraGridCell c in e.GridRow.Cells.All)
            {
                if (c.Column.Key.EndsWith("Cs"))
                {
                    csList.Add(e.CurrentColumnIndex);
                    e.Cancel = true;
                }
            }
        }

        public void HeaderCellExported(HeaderCellExportedEventArgs e)
        {



            string msn;
            //string msn_prec;
            //changes made by seema to overcome infragistics version change error on 25th July 2013 starts
          //  if (e.GridHeader.Column.Tag != null)
             if(e.GridHeader.Band.Columns.Count>e.CurrentColumnIndex)
            {
                if (e.GridHeader.Band.Columns[e.CurrentColumnIndex].Tag != null)
                {
                    //changes made by seema to overcome infragistics version change error on 25th July 2013 ends

                    //code added by seema to add merged header on temp columns in Excel Report on 17th June 2013 starts
                    //changes made by seema to overcome infragistics version change error on 25th July 2013 starts
                    // if (e.GridHeader.Column.Tag.Equals("TEMP_COL"))
                    if (e.GridHeader.Band.Columns[e.CurrentColumnIndex].Tag.Equals("TEMP_COL"))
                    {

                        msn = e.GridHeader.Band.Columns[e.CurrentColumnIndex].Tag.ToString();
                        //changes made by seema to overcome infragistics version change error on 25th July 2013 ends
                        e.CurrentWorksheet.Rows[e.CurrentRowIndex - 1].Cells[e.CurrentColumnIndex].Value = BusProject.GetInstance().GetCurrentProjectName() + "-TEMP MSN";
                        // Rcupration du format
                        IWorksheetCellFormat cellFormat = e.CurrentWorksheet.Rows[e.CurrentRowIndex].Cells[e.CurrentColumnIndex].CellFormat;
                        e.CurrentWorksheet.Rows[e.CurrentRowIndex - 1].Cells[e.CurrentColumnIndex].CellFormat.SetFormatting(cellFormat);
                        tempColCount++;
                        if (msn != currentMsn) currentMsn = msn;
                        else if (currentMsn != "" && nbofvisibleTEmpcount == tempColCount)
                        {
                            e.CurrentWorksheet.MergedCellsRegions.Clear();

                            WorksheetMergedCellsRegion region = e.CurrentWorksheet.MergedCellsRegions.Add(e.CurrentRowIndex - 1, e.CurrentColumnIndex - (nbofvisibleTEmpcount - 1),
                                e.CurrentRowIndex - 1, e.CurrentColumnIndex);

                        }
                        //if (currentMsn != "" && tempColCount == 3)
                        //{


                        //    WorksheetMergedCellsRegion region = e.CurrentWorksheet.MergedCellsRegions.Add(e.CurrentRowIndex - 1, e.CurrentColumnIndex - 2,
                        //        e.CurrentRowIndex - 1, e.CurrentColumnIndex);

                        //}
                        //if (currentMsn != "" && tempColCount == 2)
                        //{


                        //    WorksheetMergedCellsRegion region = e.CurrentWorksheet.MergedCellsRegions.Add(e.CurrentRowIndex - 1, e.CurrentColumnIndex - 1,
                        //        e.CurrentRowIndex - 1, e.CurrentColumnIndex);

                        //}
                        // }
                    }

                    else
                    {
                        //code added by seema to add merged header on temp columns in Excel Report on 17th June 2013 ends
                        //changes made by seema to overcome infragistics version change error on 25th July 2013 starts
                     //   msn = e.GridHeader.Column.Tag.ToString();
                        msn = e.GridHeader.Band.Columns[e.CurrentColumnIndex].Tag.ToString();
                        //changes made by seema to overcome infragistics version change error on 25th July 2013 ends
                        e.CurrentWorksheet.Rows[e.CurrentRowIndex - 1].Cells[e.CurrentColumnIndex].Value = "MSN " + msn;
                        // Rcupration du format
                        IWorksheetCellFormat cellFormat = e.CurrentWorksheet.Rows[e.CurrentRowIndex].Cells[e.CurrentColumnIndex].CellFormat;
                        e.CurrentWorksheet.Rows[e.CurrentRowIndex - 1].Cells[e.CurrentColumnIndex].CellFormat.SetFormatting(cellFormat);
                        if (msn != currentMsn) currentMsn = msn;
                        else if (currentMsn != "")
                        {
                            WorksheetMergedCellsRegion region = e.CurrentWorksheet.MergedCellsRegions.Add(e.CurrentRowIndex - 1, e.CurrentColumnIndex - 1,
                                e.CurrentRowIndex - 1, e.CurrentColumnIndex);
                        }
                    }
                }
                /*msn = e.GridHeader.Column.Tag.ToString();
                msn_prec = "";
                if (firstColumnToMerge == 0) firstColumnToMerge = e.CurrentColumnIndex;
                if (e.CurrentWorksheet.Rows[e.CurrentRowIndex-1].Cells[e.CurrentColumnIndex-1].Value != null)
                    msn_prec = e.CurrentWorksheet.Rows[e.CurrentRowIndex-1].Cells[e.CurrentColumnIndex-1].Value.ToString();
                // copie du msn
                e.CurrentWorksheet.Rows[e.CurrentRowIndex-1].Cells[e.CurrentColumnIndex].Value = "MSN "+ msn;
                // Rcupration du format
                IWorksheetCellFormat cellFormat = e.CurrentWorksheet.Rows[e.CurrentRowIndex].Cells[e.CurrentColumnIndex].CellFormat;
                e.CurrentWorksheet.Rows[e.CurrentRowIndex-1].Cells[e.CurrentColumnIndex].CellFormat.SetFormatting(cellFormat) ;
                if (e.GridHeader.Column.Key.EndsWith("RevAchDates"))
                {
                    WorksheetMergedCellsRegion region = e.CurrentWorksheet.MergedCellsRegions.Add(e.CurrentRowIndex-1,firstColumnToMerge,
                                                        e.CurrentRowIndex-1,e.CurrentColumnIndex);
                    firstColumnToMerge = 0;
                }*/
            }
            //if (!e.GridRow.Band.Columns.Exists("C_ACTION_ID")) nbColumnsMilestones = e.CurrentColumnIndex;

            //Rename the column header Responsible into Milestone Responsible in order to not confuse with column Responsible of actions when we repositionne 
            //actions columns

            //code for adding link column in export by Koshlendra on 21/06/2013 Start
            if (e.CurrentColumnIndex > lastMilestoneColumn) lastMilestoneColumn = e.CurrentColumnIndex;
            if (e.GridRow.Band.Key == BusMilestonesDates.CNameMonitoredMilestones)
            {
                //if (!e.GridRow.Band.Columns.Exists("C_ACTION_ID")) 
                nbColumnsMilestones = e.CurrentColumnIndex;
            }
            else if (e.GridRow.Band.Key == BusMilestonesDates.CNameRelMilestonesLinks)
            {
                nbColumnsLink = e.CurrentColumnIndex;
            }

            //Rename the column header Due Date into MILESTONE in order to not confuse with column Due Date of actions when we repositionne 
            //actions columns
            if (e.GridHeader.Caption == "Responsible")
            {
                if (e.GridHeader.Band.Key == BusMilestonesDates.CNameMonitoredMilestones)
                {
                    e.CurrentWorksheet.Rows[e.CurrentRowIndex].Cells[e.CurrentColumnIndex].Value = "Responsible";
                }
            }
            //code for adding link column in export by Koshlendra on 21/06/2013 End

        }

        public void CellExporting(CellExportingEventArgs e)
        {
            if (e.GridColumn.Key.EndsWith("Cs")) e.Cancel = true;
        }

        public void CellExported(CellExportedEventArgs e)
        {
            if (e.GridRow.Band.Key == BusMilestonesDates.CNameMonitoredMilestones)
            {
                //mettre une ligne + paisse entre chaque Milestone
                e.CurrentWorksheet.Rows[e.CurrentRowIndex].Cells[e.CurrentColumnIndex].CellFormat.TopBorderColor = Color.Black;
                e.CurrentWorksheet.Rows[e.CurrentRowIndex].Cells[e.CurrentColumnIndex].CellFormat.BottomBorderColor = Color.Black;
                if (e.CurrentColumnIndex == nbColumnsMilestones)
                    e.CurrentWorksheet.Rows[e.CurrentRowIndex].Cells[nbColumnsMilestones].CellFormat.RightBorderColor = Color.Black;
            }
            //code for adding link column in export by Koshlendra on 21/06/2013 Start
            else if (e.GridRow.Band.Key == BusMilestonesDates.CNameRelMilestonesLinks)
            {
                //Rajouter des bordures noires  chaque Rfc Global en Haut, en Bas,  Droite et  Gauche
                e.CurrentWorksheet.Rows[e.CurrentRowIndex].Cells[e.CurrentColumnIndex].CellFormat.BottomBorderColor = Color.Black;
                e.CurrentWorksheet.Rows[e.CurrentRowIndex].Cells[e.CurrentColumnIndex].CellFormat.TopBorderColor = Color.Black;
                if (e.CurrentColumnIndex == nbColumnsLink)
                    e.CurrentWorksheet.Rows[e.CurrentRowIndex].Cells[nbColumnsLink].CellFormat.RightBorderColor = Color.Black;
                if (e.CurrentColumnIndex == 1)
                    e.CurrentWorksheet.Rows[e.CurrentRowIndex].Cells[1].CellFormat.LeftBorderColor = Color.Black;

                //Save the Links excel cells adresses 
                if (e.GridColumn.Header.Caption == "Link")
                {
                    if ((e.Value != null) && (e.Value.ToString() != ""))
                        linksList.Add(new Link(e.CurrentRowIndex + 1, e.CurrentColumnIndex + 1, e.Value.ToString()));
                }
            }
            //code for adding link column in export by Koshlendra on 21/06/2013 End
            if (e.GridColumn.Editor.ToString() == "Infragistics.Win.FormattedLinkLabel.FormattedLinkEditor")
            {

                //CellValue is the text with balises
                string CellValue = e.GridRow.Cells[e.GridColumn.Index].Value.ToString();
                //Replace "&edsp;" by "&#32;" in order to be recognized by xml document
                CellValue = CellValue.Replace("&edsp;", "&#32;");

                //Cell text is the text without balises
                string CellText = e.GridRow.Cells[e.GridColumn.Index].Text;
                //Delete \r . Only \n is needed for line return
                CellText = CellText.Replace("\r", "");

                if (CellValue.Contains("<span") && CellValue.Contains("</span>"))
                {
                    FormattedString StringValue = new FormattedString(CellText);
                    e.CurrentWorksheet.Rows[e.CurrentRowIndex].Cells[e.CurrentColumnIndex].Value = StringValue;
                    MemoryStream ms = new MemoryStream(System.Text.ASCIIEncoding.ASCII.GetBytes("<span>" + CellValue + "</span>"));
                    XmlDocument xmlDoc = new XmlDocument();
                    xmlDoc.Load(ms);
                    XmlNode Node = xmlDoc.SelectSingleNode("span");
                    CtrlUtils.AddSpanPositions(Node, 0);
                    //XmlWriter w = XmlWriter.Create("C:\\Data\\writer.xml");
                    //Node.WriteContentTo(w);
                    //w.Flush();
                    //w.Close(); 
                    CtrlUtils.FormatInfragisticsExcelString(StringValue, Node);
                }
            }
        }

        public void EndExport(EndExportEventArgs e, int rowOffset, int columnOffset) //, bool isFiltered)
        {
            int milestoneColumn = 0, column = 0;

            lastMilestoneRow = e.CurrentRowIndex;
            //if (isFiltered) lastMilestoneRow -= 1;
            if (actionLine)
            {
                MergeActions(e.CurrentWorksheet, lastMilestoneRow, columnOffset, nbActions, nbColumnsMilestones);
                nbActions = 0; actionLine = false;
            }
            foreach (int i in csList)
            {
                e.CurrentWorksheet.Columns[i].Hidden = true;
                column = i;
            }
            e.CurrentWorksheet.Columns[column].Hidden = false;
            for (int iColumn = columnOffset; iColumn <= nbColumnsMilestones; iColumn++)
            {
                if (e.CurrentWorksheet.Rows[rowOffset].Cells[iColumn].Value != null)
                {
                    if (e.CurrentWorksheet.Rows[rowOffset].Cells[iColumn].Value.ToString() == "ID")
                    {
                        milestoneColumn = iColumn;
                        break;
                    }
                }
            }

            for (int iRow = rowOffset; iRow <= lastMilestoneRow; iRow++)
            {
                //e.CurrentWorksheet.Rows[iRow].Expanded = true; //Deprecated
                e.CurrentWorksheet.Rows[iRow].Hidden = false;
                if (e.CurrentWorksheet.Rows[iRow].Cells[milestoneColumn].Value != null)
                {
                    if ((e.CurrentWorksheet.Rows[iRow].Cells[milestoneColumn].Value.ToString().StartsWith("QG")) ||
                        (e.CurrentWorksheet.Rows[iRow].Cells[milestoneColumn].Value.ToString() == "ID"))
                    {
                        e.CurrentWorksheet.Rows[iRow].OutlineLevel = 0;
                    }
                    else e.CurrentWorksheet.Rows[iRow].OutlineLevel = 1;

                    if (BusMilestonesDates.GetInstance().Tables[BusMilestonesDates.CNameMilestonesActions].Rows.Count != 0)
                    {
                        //if (iRow > 1)
                        //{
                        //Set milestones actions lines borders
                        //changes made by seema for EVO06 on 21st May 2013
                        //for (int iColumn = 1; iColumn <= nbColumnsAction; iColumn++)
                        for (int iColumn = 1; iColumn < nbColumnsAction; iColumn++)
                        {
                            //Set top border and bottom border only when actions are not merged
                            //  if (!e.CurrentWorksheet.MergedCellsRegions.IsOverlappingWithMergedRegion(iRow, nbColumnsMilestones / 2, iRow, nbColumnsMilestones / 2))
                            //   {
                            // e.CurrentWorksheet.Rows[iRow].Cells[nbColumnsMilestones + iColumn].CellFormat.TopBorderColor = Color.Black;
                            /// e.CurrentWorksheet.Rows[iRow].Cells[nbColumnsMilestones + iColumn].CellFormat.BottomBorderColor = Color.Black;
                            // change by Nitin.b
                            //  e.CurrentWorksheet.Rows[iRow].Cells[iColumn].CellFormat.TopBorderColor = Color.Black;
                            //     //  e.CurrentWorksheet.Rows[iRow].Cells[iColumn].CellFormat.BottomBorderColor = Color.Black;
                            //   }
                            //added by Nitin.b
                            if (iColumn == nbColumnsAction)
                                e.CurrentWorksheet.Rows[iRow].Cells[iColumn + 1].CellFormat.RightBorderColor = Color.Black;
                        }
                        //}
                    }
                }
                else e.CurrentWorksheet.Rows[iRow].OutlineLevel = 1;
            }
        }

        private void MergeActions(Worksheet worksheet, int rowIndex, int columnOffset, int nbActions, int nbColumns)
        {
            //Merge Columns
            int firstRowToMerge = rowIndex - nbActions;
            int lastRowToMerge = rowIndex - 1;
            if (firstRowToMerge < lastRowToMerge)
            {
                for (int iColumn = columnOffset + 1; iColumn <= nbColumns + 1; iColumn++)
                {
                    if (iColumn != nbColumns + 1)
                    {
                        worksheet.MergedCellsRegions.Add(firstRowToMerge, iColumn, lastRowToMerge, iColumn);
                    }
                    //worksheet.MergedCellsRegions.Add(firstRowToMerge, iColumn, lastRowToMerge, iColumn);
                    //worksheet.MergedCellsRegions.Add(firstRowToMerge, columnOffset, lastRowToMerge, nbColumns);
                }
            }
            //Rajouter des bordures noires  la bordure du bas de la dernire ou unique action de l'ensemble d'actions appartenant  un milestone
            if (nbActions > 1)
            {

                for (int iColumn = 1; iColumn < nbColumnsAction; iColumn++)
                {
                    if (!worksheet.MergedCellsRegions.IsOverlappingWithMergedRegion(rowIndex, nbColumnsMilestones / 2, rowIndex, nbColumnsMilestones / 2))
                    {
                        worksheet.Rows[firstRowToMerge].Cells[nbColumns + iColumn].CellFormat.TopBorderColor = Color.Black;
                        worksheet.Rows[lastRowToMerge].Cells[nbColumns + iColumn].CellFormat.BottomBorderColor = Color.Black;
                    }

                }
            }
            //Rajouter des bordures  gauche et  droite de chaque ligne d'action
            //removing index error
            for (int iRow = firstRowToMerge; iRow <= lastRowToMerge; iRow++)
            {
                worksheet.Rows[iRow].Cells[nbColumns + 1].CellFormat.LeftBorderColor = Color.Black;
                worksheet.Rows[iRow].Cells[nbColumns + nbColumnsAction].CellFormat.RightBorderColor = Color.Black;
            }
            int starColumn = columnOffset;
            for (int iRow = firstRowToMerge + 1; iRow <= lastRowToMerge; iRow++)
            {
                //worksheet.Rows[iRow].Cells[starColumn].
                worksheet.Rows[iRow].Cells[starColumn].Value = worksheet.Rows[firstRowToMerge].Cells[starColumn].Value;
                worksheet.Rows[iRow].Cells[starColumn].CellFormat.SetFormatting(worksheet.Rows[firstRowToMerge].Cells[starColumn].CellFormat);
                worksheet.Rows[iRow].Cells[starColumn].CellFormat.TopBorderStyle = CellBorderLineStyle.Thin;
                worksheet.Rows[iRow].Cells[starColumn].CellFormat.TopBorderColor = Color.LightGray;
            }
        }
    }
}
