using System.Drawing;
using Infragistics.Documents.Excel;
using Infragistics.Win.UltraWinGrid.ExcelExport;
using com.airbus.pm00.model;
using com.airbus.pm00.controller.util;
using System.IO;
using System.Xml;
using System.Collections;
using System.Windows.Forms;
using Infragistics.Win.UltraWinGrid;

namespace com.airbus.pm00.controller
{
	public class CtrlExcelExportMscn
	{
		private static CtrlExcelExportMscn _CtrlExcelExportMscn_Singleton = null;

		public int nbColumnsMscn = 0;
		private bool actionLineMscn = false;
		private int nbActionsMscn = 0;
		private int rememberCurrentRowMscn = 0;

		public int lastMscnColumn = 0;
		public int lastMscnRow = 0;
        private int nbColumnsAction = 0;

        public ArrayList linksList = new ArrayList();
        private int nbColumnsLink = 0;
        private int linkHeaderLine = 0;
        private int rememberCurrentRowLink = 0;
        private bool linkLine = false;

		public CtrlExcelExportMscn()
		{
		}

		public static CtrlExcelExportMscn GetInstance()
		{
			//creer une nouvelle instance s il n'en existe pas deja une autre
			if(_CtrlExcelExportMscn_Singleton == null) _CtrlExcelExportMscn_Singleton = new CtrlExcelExportMscn();
			return _CtrlExcelExportMscn_Singleton;
		}

		public void BeginExport(BeginExportEventArgs e)
		{
			nbColumnsMscn = 0;
			nbActionsMscn = 0;
			rememberCurrentRowMscn = 0;
			lastMscnColumn = 0;
			lastMscnRow = 0;
            nbColumnsAction = 0;

            linksList.Clear();
            nbColumnsLink = 0;
            linkHeaderLine = 0;
            rememberCurrentRowLink = 0;
            linkLine = false;

            foreach (UltraGridColumn col in CtrlMain.GetInstance().UiM.UgrMSCN.DisplayLayout.Bands[BusMSCNs.CNameRelMSCNAction].Groups[BusMSCNs.CNameRelMSCNAction]. Columns)
            {   
                if (col.IsVisibleInLayout) nbColumnsAction++;
            }
		}

		public void HeaderRowExporting(HeaderRowExportingEventArgs e, int rowOffset, int columnOffset)
		{
            if (e.Band.Columns.Exists("C_ACTION_ID"))
            {
                UltraGridBand parentBand = e.Band.ParentBand;
                if (parentBand.Key == BusMSCNs.CNameMSCN)
                {
                    rememberCurrentRowMscn = e.CurrentRowIndex - 2;
                    e.CurrentColumnIndex = nbColumnsMscn + 1;
                    e.CurrentRowIndex = rowOffset;
                }
                else if (parentBand.Key == BusMSCNs.CNameRelMSCNLink)
                {
                    rememberCurrentRowLink = e.CurrentRowIndex-2;
                    e.CurrentColumnIndex = nbColumnsLink+1;
                    e.CurrentRowIndex = linkHeaderLine;
                }
            }
            else if (e.Band.Key == BusMSCNs.CNameRelMSCNLink)
            {
                e.CurrentRowIndex = e.CurrentRowIndex - 1;
                if (actionLineMscn)
                {
                    MergeActions(e.CurrentWorksheet, e.CurrentRowIndex, columnOffset, nbActionsMscn, nbColumnsMscn);
                    nbActionsMscn = 0;
                    actionLineMscn = false;
                }
                linkHeaderLine = e.CurrentRowIndex;
                //e.CurrentWorksheet.Rows[e.CurrentRowIndex].Cells[columnToIdentifyOutPointOrLink].Value = "L";
            }
		}

		public void HeaderRowExported(HeaderRowExportedEventArgs e)
		{
			if (e.Band.Columns.Exists("C_ACTION_ID"))
            {
                UltraGridBand parentBand = e.Band.ParentBand;
                if (parentBand.Key == BusMSCNs.CNameMSCN)
                {
                    e.CurrentRowIndex = rememberCurrentRowMscn;
                }
                else if (parentBand.Key == BusMSCNs.CNameRelMSCNLink)
                {
                    e.CurrentRowIndex = rememberCurrentRowLink;
                }    
            }
		}

		public void RowExporting(RowExportingEventArgs e, int columnOffset)
		{
			if (e.GridRow.Band.Columns.Exists("C_ACTION_ID"))
			{
                UltraGridBand parentBand = e.GridRow.Band.ParentBand;
                if (parentBand.Key == BusMSCNs.CNameMSCN)
                {
                    e.CurrentColumnIndex = nbColumnsMscn + 1;
                    nbActionsMscn = nbActionsMscn+1;
   				    actionLineMscn = true;
                }
                else if (parentBand.Key == BusMSCNs.CNameRelMSCNLink)
                {
                    //band rfc action
                    e.CurrentColumnIndex = nbColumnsLink + 1;
                    //e.CurrentWorksheet.Rows[e.CurrentRowIndex].Cells[columnToIdentifyOutPointOrLink].Value = "L";
                }
			}
			else if (actionLineMscn)
			{
				e.CurrentRowIndex = e.CurrentRowIndex-1;
				//if (nbActionsMscn > 1) MergeActions(e.CurrentWorksheet, e.CurrentRowIndex, columnOffset, nbActionsMscn, nbColumnsMscn);
				MergeActions(e.CurrentWorksheet, e.CurrentRowIndex, columnOffset, nbActionsMscn, nbColumnsMscn);
				nbActionsMscn = 0;
				actionLineMscn = false;
			}
            if (e.GridRow.Band.Key == BusMSCNs.CNameMSCN&& linkLine)
                e.CurrentRowIndex = e.CurrentRowIndex - 1;
            if (e.GridRow.Band.Key == BusMSCNs.CNameRelMSCNLink)
                linkLine = true;
            else linkLine = false;
		}

		public void HeaderCellExported(HeaderCellExportedEventArgs e)
		{
			if (e.CurrentColumnIndex > lastMscnColumn) lastMscnColumn = e.CurrentColumnIndex;
            if (e.GridRow.Band.Key == BusMSCNs.CNameMSCN)
            {
                //if (!e.GridRow.Band.Columns.Exists("C_ACTION_ID")) 
                nbColumnsMscn = e.CurrentColumnIndex;
            }
            else if (e.GridRow.Band.Key == BusMSCNs.CNameRelMSCNLink)
            {
                nbColumnsLink = e.CurrentColumnIndex;
            }

            //Rename the column header Due Date into MSCN in order to not confuse with column Due Date of actions when we repositionne 
            //actions columns
            if (e.GridHeader.Caption == "Due Date")
            {
                if (e.GridHeader.Band.Key == BusMSCNs.CNameMSCN)
                    e.CurrentWorksheet.Rows[e.CurrentRowIndex].Cells[e.CurrentColumnIndex].Value = "MSCN Due Date";
            }
		}

		public void CellExported(CellExportedEventArgs e)
		{
			if (e.GridColumn.Key == "C_MSCN_SELECTED")
			{
				if (int.Parse(e.Value.ToString()) == 1) e.CurrentWorksheet.Rows[e.CurrentRowIndex].Cells[e.CurrentColumnIndex].Value = "*";
				else e.CurrentWorksheet.Rows[e.CurrentRowIndex].Cells[e.CurrentColumnIndex].Value = "";
			}
			if (e.GridRow.Band.Key == BusMSCNs.CNameMSCN)
			{
                //Rajouter des bordures noires  chaque MSCN en Haut, en Bas et  Droite				
				e.CurrentWorksheet.Rows[e.CurrentRowIndex].Cells[e.CurrentColumnIndex].CellFormat.TopBorderColor = Color.Black;
                e.CurrentWorksheet.Rows[e.CurrentRowIndex].Cells[e.CurrentColumnIndex].CellFormat.BottomBorderColor = Color.Black;
                if (e.CurrentColumnIndex == nbColumnsMscn)
                    e.CurrentWorksheet.Rows[e.CurrentRowIndex].Cells[nbColumnsMscn].CellFormat.RightBorderColor = Color.Black;
			}
            else if (e.GridRow.Band.Key == BusMSCNs.CNameRelMSCNLink)
            {
                //Rajouter des bordures noires  chaque Rfc Global en Haut, en Bas,  Droite et  Gauche
                e.CurrentWorksheet.Rows[e.CurrentRowIndex].Cells[e.CurrentColumnIndex].CellFormat.BottomBorderColor = Color.Black;
                e.CurrentWorksheet.Rows[e.CurrentRowIndex].Cells[e.CurrentColumnIndex].CellFormat.TopBorderColor = Color.Black;
                if (e.CurrentColumnIndex == nbColumnsLink)
                    e.CurrentWorksheet.Rows[e.CurrentRowIndex].Cells[nbColumnsLink].CellFormat.RightBorderColor = Color.Black;
                if (e.CurrentColumnIndex == 1)
                    e.CurrentWorksheet.Rows[e.CurrentRowIndex].Cells[1].CellFormat.LeftBorderColor = Color.Black;

                //Save the Links excel cells adresses 
                if (e.GridColumn.Header.Caption == "Link")
                {
                    if ((e.Value != null) && (e.Value.ToString() != ""))
                        linksList.Add(new Link(e.CurrentRowIndex + 1, e.CurrentColumnIndex + 1, e.Value.ToString()));
                }
            }

            if (e.GridColumn.Editor.ToString() == "Infragistics.Win.FormattedLinkLabel.FormattedLinkEditor")
            {
                //CellValue is the text with balises
                string CellValue = e.GridRow.Cells[e.GridColumn.Index].Value.ToString();
                //Replace "&edsp;" by "&#32;" in order to be recognized by xml document
                CellValue = CellValue.Replace("&edsp;", "&#32;");

                //Cell text is the text without balises
                string CellText = e.GridRow.Cells[e.GridColumn.Index].Text;
                //Delete \r . Only \n is needed for line return
                CellText = CellText.Replace("\r", "");

                if (CellValue.Contains("<span") && CellValue.Contains("</span>"))
                {
                    FormattedString StringValue = new FormattedString(CellText);
                    e.CurrentWorksheet.Rows[e.CurrentRowIndex].Cells[e.CurrentColumnIndex].Value = StringValue;
                    MemoryStream ms = new MemoryStream(System.Text.ASCIIEncoding.ASCII.GetBytes("<span>" + CellValue + "</span>"));
                    XmlDocument xmlDoc = new XmlDocument();
                    xmlDoc.Load(ms);
                    XmlNode Node = xmlDoc.SelectSingleNode("span");
                    CtrlUtils.AddSpanPositions(Node, 0);
                    CtrlUtils.FormatInfragisticsExcelString(StringValue, Node);
                }
            }
		}

        public void EndExport(EndExportEventArgs e, int rowOffset, int columnOffset) //, bool isFiltered)
		{
			lastMscnRow = e.CurrentRowIndex;
            //if (isFiltered) lastMscnRow -= 1;
			if (actionLineMscn)
			{
                MergeActions(e.CurrentWorksheet, lastMscnRow, columnOffset, nbActionsMscn, nbColumnsMscn);
				nbActionsMscn = 0;
				actionLineMscn = false;
			}
            for (int iRow = rowOffset; iRow <= lastMscnRow; iRow++)
			{
                //e.CurrentWorksheet.Rows[iRow].Expanded = true; //Deprecated
                e.CurrentWorksheet.Rows[iRow].Hidden = false;
				e.CurrentWorksheet.Rows[iRow].OutlineLevel = 0;

                if (BusMSCNs.GetInstance().Tables[BusMSCNs.CNameMSCNAction].Rows.Count != 0)
                {
                    if (iRow != lastMscnRow)
                    {
                        //Set rfc actions lines borders
                        for (int iColumn = 1; iColumn < nbColumnsAction; iColumn++)
                        {
                            //Set top border and bottom border only when actions are not merged
                            if (!e.CurrentWorksheet.MergedCellsRegions.IsOverlappingWithMergedRegion(iRow, nbColumnsMscn / 2, iRow, nbColumnsMscn / 2))
                            {
                                //e.CurrentWorksheet.Rows[iRow].Cells[nbColumnsAction].CellFormat.TopBorderColor = Color.Black;
                                //e.CurrentWorksheet.Rows[iRow].Cells[nbColumnsAction].CellFormat.BottomBorderColor = Color.Black;
                                //e.CurrentWorksheet.Rows[iRow].Cells[nbColumnsMscn + iColumn].CellFormat.TopBorderColor = Color.Black;
                               // e.CurrentWorksheet.Rows[iRow].Cells[nbColumnsMscn + iColumn].CellFormat.BottomBorderColor = Color.Black;
                               // e.CurrentWorksheet.Rows[iRow].Cells[ iColumn].CellFormat.TopBorderColor = Color.Black;
                                 //   e.CurrentWorksheet.Rows[iRow].Cells[iColumn].CellFormat.BottomBorderColor = Color.Black;
                            }
                            if (iColumn == nbColumnsAction)
                                e.CurrentWorksheet.Rows[iRow].Cells[iColumn+1].CellFormat.RightBorderColor = Color.Black;

                               // e.CurrentWorksheet.Rows[iRow].Cells[nbColumnsMscn + iColumn].CellFormat.RightBorderColor = Color.Black;
                        }
                    }                   
                }
			}
		}

		private void MergeActions(Worksheet worksheet, int rowIndex, int columnOffset, int nbActions, int nbColumns)
		{
			//Merge Columns
			int firstRowToMerge = rowIndex-nbActions;
			int lastRowToMerge = rowIndex-1;
            //int nbColumnsActions = CtrlMain.GetInstance().UiM.UgrMSCN.DisplayLayout.Bands[BusMSCNs.CNameRelMSCNAction].Columns.BoundColumnsCount;

			//Do not merge * cells
            if (firstRowToMerge < lastRowToMerge)
            {
                for (int iColumn = columnOffset+1 ; iColumn < nbColumns; iColumn++)
                {
                    //if (iColumn != nbColumns )
                    //{
                    //    worksheet.MergedCellsRegions.Add(firstRowToMerge, iColumn, lastRowToMerge, iColumn);
                    //}
              //worksheet.MergedCellsRegions.Add(firstRowToMerge, iColumn, lastRowToMerge, iColumn);
                 //  worksheet.MergedCellsRegions.Add(firstRowToMerge, columnOffset+1, lastRowToMerge, nbColumns);
                }
            }
            //Rajouter des bordures noires  la bordure du bas de la dernire ou unique action de l'ensemble d'actions appartenant  un mscn
            if (nbActions > 1)
            {
                for (int iColumn = 1; iColumn <= nbColumnsAction; iColumn++)
                {
                    worksheet.Rows[firstRowToMerge].Cells[nbColumns + iColumn].CellFormat.TopBorderColor = Color.Black;
                    worksheet.Rows[lastRowToMerge].Cells[nbColumns + iColumn].CellFormat.BottomBorderColor = Color.Black;
                }
            }
            //Rajouter des bordures  gauche et  droite de chaque ligne d'action
            for (int iRow = firstRowToMerge; iRow <= lastRowToMerge; iRow++)
            {
                //worksheet.Rows[iRow].Cells[nbColumns + 1].CellFormat.LeftBorderColor = Color.Black;
                worksheet.Rows[iRow].Cells[nbColumns + nbColumnsAction].CellFormat.RightBorderColor = Color.Black;
            }
			//recopier la valeur de l'* sur toutes les lignes
			int starColumn = columnOffset;
			for (int iRow = firstRowToMerge+1; iRow<=lastRowToMerge; iRow++)
			{
				worksheet.Rows[iRow].Cells[starColumn].Value = worksheet.Rows[firstRowToMerge].Cells[starColumn].Value;
				worksheet.Rows[iRow].Cells[starColumn].CellFormat.SetFormatting(worksheet.Rows[firstRowToMerge].Cells[starColumn].CellFormat);
				worksheet.Rows[iRow].Cells[starColumn].CellFormat.TopBorderStyle = CellBorderLineStyle.Thin;
				worksheet.Rows[iRow].Cells[starColumn].CellFormat.TopBorderColor = Color.LightGray;
			}  
		}
	}
}
