using System.Drawing;
using Infragistics.Documents.Excel;
using Infragistics.Win.UltraWinGrid;
using Infragistics.Win.UltraWinGrid.ExcelExport;
using com.airbus.pm00.model;
using System.Windows.Forms;
using Infragistics.Win.FormattedLinkLabel;
using System.IO;
using System.Xml;
using com.airbus.pm00.controller.util;
using System.Collections;


namespace com.airbus.pm00.controller
{
    public class CtrlExcelExportRfc
    {
        private static CtrlExcelExportRfc _CtrlExcelExportRfc_Singleton = null;

        public int nbColumnsRfc = 0;
        private bool actionLineRfc = false;
        private int nbActionsRfc = 0;
        private int rememberCurrentRowRfc = 0;

        private int nbColumnsRfcGlobal = 0;
        private int globalRfcHeaderLine = 0;
        private int rememberCurrentRowRfcGlobal = 0;
        private bool actionLineRfcGlobal = false;
        private bool globalRfcLine = false;
        private int nbActionsRfcGlobal = 0;

        public int lastRfcColumn = 0;
        public int lastRfcRow = 0;
        public int columnToIdentifyRfcOrGlobal = 60;
        private int nbColumnsAction = 0;
        private int nbColumnsGlobalAction = 0;

        public ArrayList linksList = new ArrayList();
        private int nbColumnsLink = 0;
        private int linkHeaderLine = 0;
        private int rememberCurrentRowLink = 0;
        private bool linkLine = false;

        public CtrlExcelExportRfc()
        {
        }

        public static CtrlExcelExportRfc GetInstance()
        {
            //creer une nouvelle instance s il n'en existe pas deja une autre
            if (_CtrlExcelExportRfc_Singleton == null) _CtrlExcelExportRfc_Singleton = new CtrlExcelExportRfc();
            return _CtrlExcelExportRfc_Singleton;
        }

        public void BeginExport(BeginExportEventArgs e)
        {
            nbColumnsRfc = 0;
            nbActionsRfc = 0;
            rememberCurrentRowRfc = 0;
            actionLineRfc = false;

            nbColumnsRfcGlobal = 0;
            globalRfcHeaderLine = 0;
            rememberCurrentRowRfcGlobal = 0;
            nbActionsRfcGlobal = 0;
            actionLineRfcGlobal = false;
            globalRfcLine = false;

            lastRfcColumn = 0;
            lastRfcRow = 0;
            nbColumnsAction = 0;
            nbColumnsGlobalAction = 0;

            nbColumnsLink = 0;
            linkHeaderLine = 0;
            rememberCurrentRowLink = 0;
            linkLine = false;
            linksList.Clear();

            foreach (UltraGridColumn col in CtrlMain.GetInstance().UiM.UgrRFC.DisplayLayout.Bands[BusRFCs.CNameRelRFCAction].Columns)
            {
                if (col.IsVisibleInLayout) nbColumnsAction++;
            }

            foreach (UltraGridColumn col in CtrlMain.GetInstance().UiM.UgrRFC.DisplayLayout.Bands[BusRFCs.CNameRelGlobalRFCAction].Columns)
            {
                if (col.IsVisibleInLayout) nbColumnsGlobalAction++;
            }
        }

        public void HeaderRowExporting(HeaderRowExportingEventArgs e, int rowOffset, int columnOffset)
        {
            if (e.Band.Columns.Exists("C_ACTION_ID"))
            {
                UltraGridBand parentBand = e.Band.ParentBand;
                if (parentBand.Key == BusRFCs.CNameRFC)
                {
                    rememberCurrentRowRfc = e.CurrentRowIndex - 2;
                    e.CurrentColumnIndex = nbColumnsRfc + 1;
                    e.CurrentRowIndex = rowOffset;
                }
                else if (parentBand.Key == BusRFCs.CNameRelRFCGlobalRFC)
                {
                    rememberCurrentRowRfcGlobal = e.CurrentRowIndex - 2;
                    e.CurrentColumnIndex = nbColumnsRfcGlobal + 1;
                    e.CurrentRowIndex = globalRfcHeaderLine;
                }
                else if (parentBand.Key == BusRFCs.CNameRelRFCLink)
                {
                    rememberCurrentRowLink = e.CurrentRowIndex - 2;
                    e.CurrentColumnIndex = nbColumnsLink + 1;
                    e.CurrentRowIndex = linkHeaderLine;
                }
            }
            else if (e.Band.Key == BusRFCs.CNameRelRFCGlobalRFC)
            {
                e.CurrentRowIndex = e.CurrentRowIndex - 1;
                if (actionLineRfc)
                {
                    //if (nbActionsRfc > 1) MergeActions(e.CurrentWorksheet, e.CurrentRowIndex, columnOffset, nbActionsRfc, nbColumnsRfc);
                    MergeActions(e.CurrentWorksheet, e.CurrentRowIndex, columnOffset, nbActionsRfc, nbColumnsRfc);
                    nbActionsRfc = 0;
                    actionLineRfc = false;
                }
                globalRfcHeaderLine = e.CurrentRowIndex;
                e.CurrentWorksheet.Rows[e.CurrentRowIndex].Cells[columnToIdentifyRfcOrGlobal].Value = "G";
            }
            else if (e.Band.Key == BusRFCs.CNameRelRFCLink)
            {
                e.CurrentRowIndex = e.CurrentRowIndex - 1;
                if (actionLineRfc)
                {
                    //if (nbActionsRfc > 1) MergeActions(e.CurrentWorksheet, e.CurrentRowIndex, columnOffset, nbActionsRfc, nbColumnsRfc);
                    MergeActions(e.CurrentWorksheet, e.CurrentRowIndex, columnOffset, nbActionsRfc, nbColumnsRfc);
                    nbActionsRfc = 0;
                    actionLineRfc = false;
                }
                if (actionLineRfcGlobal)
                {
                    MergeActions(e.CurrentWorksheet, e.CurrentRowIndex, columnOffset, nbActionsRfcGlobal, nbColumnsRfcGlobal);
                    nbActionsRfcGlobal = 0;
                    actionLineRfcGlobal = false;
                }
                linkHeaderLine = e.CurrentRowIndex;
                //e.CurrentWorksheet.Rows[e.CurrentRowIndex].Cells[columnToIdentifyRfcOrGlobal].Value = "L";
            }
        }

        public void HeaderRowExported(HeaderRowExportedEventArgs e)
        {
            if (e.Band.Columns.Exists("C_ACTION_ID"))
            {
                UltraGridBand parentBand = e.Band.ParentBand;
                if (parentBand.Key == BusRFCs.CNameRFC)
                {
                    e.CurrentRowIndex = rememberCurrentRowRfc;
                }
                else if (parentBand.Key == BusRFCs.CNameRelRFCGlobalRFC)
                {
                    e.CurrentRowIndex = rememberCurrentRowRfcGlobal;
                }
                else if (parentBand.Key == BusRFCs.CNameRelRFCLink)
                {
                    e.CurrentRowIndex = rememberCurrentRowLink;
                }
            }
        }

        public void RowExporting(RowExportingEventArgs e, int columnOffset)
        {
            if (e.GridRow.Band.Columns.Exists("C_ACTION_ID"))
            {
                //Band RFC action ou band global RFC action
                UltraGridBand parentBand = e.GridRow.Band.ParentBand;
                if (parentBand.Key == BusRFCs.CNameRFC)
                {
                    //band rfc action
                    e.CurrentColumnIndex = nbColumnsRfc + 1;
                    nbActionsRfc = nbActionsRfc + 1;
                    actionLineRfc = true;
                    e.CurrentWorksheet.Rows[e.CurrentRowIndex].Cells[columnToIdentifyRfcOrGlobal].Value = "R";
                }
                else if (parentBand.Key == BusRFCs.CNameRelRFCGlobalRFC)
                {
                    //band rfc action
                    e.CurrentColumnIndex = nbColumnsRfcGlobal + 1;
                    nbActionsRfcGlobal = nbActionsRfcGlobal + 1;
                    actionLineRfcGlobal = true;
                    e.CurrentWorksheet.Rows[e.CurrentRowIndex].Cells[columnToIdentifyRfcOrGlobal].Value = "G";
                }
            }
            else if (actionLineRfc)
            {
                e.CurrentRowIndex = e.CurrentRowIndex - 1;
                //if (nbActionsRfc > 1) MergeActions(e.CurrentWorksheet, e.CurrentRowIndex, columnOffset, nbActionsRfc, nbColumnsRfc);
                MergeActions(e.CurrentWorksheet, e.CurrentRowIndex, columnOffset, nbActionsRfc, nbColumnsRfc);
                nbActionsRfc = 0;
                actionLineRfc = false;
            }
            else if (actionLineRfcGlobal)
            {
                e.CurrentRowIndex = e.CurrentRowIndex - 1;
                //if (nbActionsRfcGlobal > 1) MergeActions(e.CurrentWorksheet, e.CurrentRowIndex, columnOffset, nbActionsRfcGlobal, nbColumnsRfcGlobal);
                MergeActions(e.CurrentWorksheet, e.CurrentRowIndex, columnOffset, nbActionsRfcGlobal, nbColumnsRfcGlobal);
                nbActionsRfcGlobal = 0;
                actionLineRfcGlobal = false;
            }
            if (e.GridRow.Band.Key == BusRFCs.CNameRFC && globalRfcLine)
                e.CurrentRowIndex = e.CurrentRowIndex - 1;
            if (e.GridRow.Band.Key == BusRFCs.CNameRelRFCGlobalRFC)
                globalRfcLine = true;
            else globalRfcLine = false;

            if (e.GridRow.Band.Key == BusRFCs.CNameRFC && linkLine)
                e.CurrentRowIndex = e.CurrentRowIndex - 1;
            if (e.GridRow.Band.Key == BusRFCs.CNameRelRFCLink)
                linkLine = true;
            else linkLine = false;

            if (e.GridRow.Band.Key == BusRFCs.CNameRelRFCGlobalRFC)
                e.CurrentWorksheet.Rows[e.CurrentRowIndex].Cells[columnToIdentifyRfcOrGlobal].Value = "G";
            else if (e.GridRow.Band.Key == BusRFCs.CNameRFC)
                e.CurrentWorksheet.Rows[e.CurrentRowIndex].Cells[columnToIdentifyRfcOrGlobal].Value = "R";
            //else if (e.GridRow.Band.Key == BusRFCs.CNameRelRFCLink)
            //    e.CurrentWorksheet.Rows[e.CurrentRowIndex].Cells[columnToIdentifyRfcOrGlobal].Value = "L";
        }

        public void HeaderCellExported(HeaderCellExportedEventArgs e)
        {
            if (e.CurrentColumnIndex > lastRfcColumn) lastRfcColumn = e.CurrentColumnIndex;
            if (e.GridRow.Band.Key == BusRFCs.CNameRFC) nbColumnsRfc = e.CurrentColumnIndex;
            else if (e.GridRow.Band.Key == BusRFCs.CNameRelRFCGlobalRFC)
                nbColumnsRfcGlobal = e.CurrentColumnIndex;
            else if (e.GridRow.Band.Key == BusRFCs.CNameRelRFCLink)
                nbColumnsLink = e.CurrentColumnIndex;
        }

        public void CellExported(CellExportedEventArgs e)
        {
            if ((e.GridColumn.Key == "C_RFC_SELECTED") || (e.GridColumn.Key == "C_RFC_GLOBAL_SELECTED"))
            {
                if (int.Parse(e.Value.ToString()) == 1) e.CurrentWorksheet.Rows[e.CurrentRowIndex].Cells[e.CurrentColumnIndex].Value = "*";
                else e.CurrentWorksheet.Rows[e.CurrentRowIndex].Cells[e.CurrentColumnIndex].Value = "";
            }
            if (e.GridRow.Band.Key == BusRFCs.CNameRFC)
            {
                //Rajouter des bordures noires  chaque Rfc en Haut, en Bas et  Droite
                e.CurrentWorksheet.Rows[e.CurrentRowIndex].Cells[e.CurrentColumnIndex].CellFormat.BottomBorderColor = Color.Black;
                e.CurrentWorksheet.Rows[e.CurrentRowIndex].Cells[e.CurrentColumnIndex].CellFormat.TopBorderColor = Color.Black;
                if (e.CurrentColumnIndex == nbColumnsRfc)
                    e.CurrentWorksheet.Rows[e.CurrentRowIndex].Cells[nbColumnsRfc].CellFormat.RightBorderColor = Color.Black;
            }
            else if (e.GridRow.Band.Key == BusRFCs.CNameRelRFCGlobalRFC)
            {
                //Rajouter des bordures noires  chaque Rfc Global en Haut, en Bas,  Droite et  Gauche
                e.CurrentWorksheet.Rows[e.CurrentRowIndex].Cells[e.CurrentColumnIndex].CellFormat.BottomBorderColor = Color.Black;
                e.CurrentWorksheet.Rows[e.CurrentRowIndex].Cells[e.CurrentColumnIndex].CellFormat.TopBorderColor = Color.Black;
                if (e.CurrentColumnIndex == nbColumnsRfcGlobal)
                    e.CurrentWorksheet.Rows[e.CurrentRowIndex].Cells[nbColumnsRfcGlobal].CellFormat.RightBorderColor = Color.Black;
                if (e.CurrentColumnIndex == 1)
                    e.CurrentWorksheet.Rows[e.CurrentRowIndex].Cells[1].CellFormat.LeftBorderColor = Color.Black;
            }
            else if (e.GridRow.Band.Key == BusRFCs.CNameRelRFCLink)
            {
                //Rajouter des bordures noires  chaque Rfc Global en Haut, en Bas,  Droite et  Gauche
                e.CurrentWorksheet.Rows[e.CurrentRowIndex].Cells[e.CurrentColumnIndex].CellFormat.BottomBorderColor = Color.Black;
                e.CurrentWorksheet.Rows[e.CurrentRowIndex].Cells[e.CurrentColumnIndex].CellFormat.TopBorderColor = Color.Black;
                if (e.CurrentColumnIndex == nbColumnsLink)
                    e.CurrentWorksheet.Rows[e.CurrentRowIndex].Cells[nbColumnsLink].CellFormat.RightBorderColor = Color.Black;
                if (e.CurrentColumnIndex == 1)
                    e.CurrentWorksheet.Rows[e.CurrentRowIndex].Cells[1].CellFormat.LeftBorderColor = Color.Black;

                //Save the Links excel cells adresses 
                if (e.GridColumn.Header.Caption == "Link")
                {
                    if ((e.Value != null) && (e.Value.ToString() != ""))
                        linksList.Add(new Link(e.CurrentRowIndex + 1, e.CurrentColumnIndex + 1, e.Value.ToString()));
                }
            }
            if (e.GridColumn.Editor.ToString() == "Infragistics.Win.FormattedLinkLabel.FormattedLinkEditor")
            {
                try
                {
                    //CellValue is the text with balises
                    string CellValue = e.GridRow.Cells[e.GridColumn.Index].Value.ToString();
                    //Replace "&edsp;" by "&#32;" in order to be recognized by xml document
                    CellValue = CellValue.Replace("&edsp;", "&#32;");

                    //Cell text is the text without balises
                    string CellText = e.GridRow.Cells[e.GridColumn.Index].Text;
                    //Delete \r . Only \n is needed for line return
                    CellText = CellText.Replace("\r", "");

                    if (CellValue.Contains("<span") && CellValue.Contains("</span>"))
                    {
                        FormattedString StringValue = new FormattedString(CellText);
                        e.CurrentWorksheet.Rows[e.CurrentRowIndex].Cells[e.CurrentColumnIndex].Value = StringValue;
                        MemoryStream ms = new MemoryStream(System.Text.ASCIIEncoding.ASCII.GetBytes("<span>" + CellValue + "</span>"));
                        XmlDocument xmlDoc = new XmlDocument();
                        xmlDoc.Load(ms);
                        XmlNode Node = xmlDoc.SelectSingleNode("span");
                        CtrlUtils.AddSpanPositions(Node, 0);
                        CtrlUtils.FormatInfragisticsExcelString(StringValue, Node);
                    }
                }
                catch (FCOException ex)
                { }
            }
        }

        public void EndExport(EndExportEventArgs e, int rowOffset, int columnOffset) //, bool isFiltered)
        {
            lastRfcRow = e.CurrentRowIndex;
            //if (isFiltered) lastRfcRow -= 1;
            if (actionLineRfc)
            {
                MergeActions(e.CurrentWorksheet, lastRfcRow, columnOffset, nbActionsRfc, nbColumnsRfc);
                nbActionsRfc = 0; actionLineRfc = false;
            }
            else if (actionLineRfcGlobal)
            {
                MergeActions(e.CurrentWorksheet, lastRfcRow, columnOffset, nbActionsRfcGlobal, nbColumnsRfcGlobal);
                nbActionsRfcGlobal = 0; actionLineRfcGlobal = false;
            }
            for (int iRow = rowOffset; iRow <= lastRfcRow; iRow++)
            {
                //e.CurrentWorksheet.Rows[iRow].Expanded = true; //Deprecated
                e.CurrentWorksheet.Rows[iRow].Hidden = false;
                e.CurrentWorksheet.Rows[iRow].OutlineLevel = 0;
                if (e.CurrentWorksheet.Rows[iRow].Cells[columnToIdentifyRfcOrGlobal].Value != null)
                {
                    if (e.CurrentWorksheet.Rows[iRow].Cells[columnToIdentifyRfcOrGlobal].Value.ToString() == "G")
                    {
                        e.CurrentWorksheet.Rows[iRow].OutlineLevel = 1;

                        if (BusRFCs.GetInstance().Tables[BusRFCs.CNameRFCAction].Rows.Count != 0)
                        {

                            //Set global rfc actions lines borders
                            //commented and changes made by seema for evo06
                            //for (int iColumn = 1; iColumn <= nbColumnsGlobalAction; iColumn++)
                            for (int iColumn = 1; iColumn < nbColumnsRfcGlobal; iColumn++)
                            //changes made by seema for evo06 ends
                            {
                                //Set top border and bottom border only when actions are not merged
                                if (!e.CurrentWorksheet.MergedCellsRegions.IsOverlappingWithMergedRegion(iRow, nbColumnsRfcGlobal / 2, iRow, nbColumnsRfcGlobal / 2))
                                {
                                    //changes made by seema for evo06
                                    //e.CurrentWorksheet.Rows[iRow].Cells[nbColumnsRfcGlobal + iColumn].CellFormat.TopBorderColor = Color.Black;
                                    // e.CurrentWorksheet.Rows[iRow].Cells[nbColumnsRfcGlobal + iColumn].CellFormat.BottomBorderColor = Color.Black;
                                    e.CurrentWorksheet.Rows[iRow].Cells[iColumn].CellFormat.TopBorderColor = Color.Black;
                                    e.CurrentWorksheet.Rows[iRow].Cells[iColumn].CellFormat.BottomBorderColor = Color.Black;
                                    //changes made by seema for evo06
                                }

                                //code chhanged for evo12 by Koshlendra Pratap Singh on 23/05/2013 start
                                if (iColumn == nbColumnsGlobalAction)
                                    e.CurrentWorksheet.Rows[iRow].Cells[iColumn + 1].CellFormat.RightBorderColor = Color.Black;
                                if (iColumn == 1)
                                    e.CurrentWorksheet.Rows[iRow].Cells[iColumn + 1].CellFormat.LeftBorderColor = Color.Black;
                                //code chhanged for evo12 by Koshlendra Pratap Singh on 23/05/2013 End
                            }
                        }
                    }
                    //if (e.CurrentWorksheet.Rows[iRow].Cells[columnToIdentifyRfcOrGlobal].Value.ToString() == "L")
                    //{
                    //    e.CurrentWorksheet.Rows[iRow].OutlineLevel = 1;
                    //}
                    else
                    {

                        //Set rfc actions lines borders
                        for (int iColumn = 1; iColumn < nbColumnsAction; iColumn++)
                        {
                            //Set top border and bottom border only when actions are not merged
                            if (!e.CurrentWorksheet.MergedCellsRegions.IsOverlappingWithMergedRegion(iRow, nbColumnsRfc / 2, iRow, nbColumnsRfc / 2))
                            {
                                //code changes by seema for evo06 starts
                                // e.CurrentWorksheet.Rows[iRow].Cells[nbColumnsRfc + iColumn].CellFormat.TopBorderColor = Color.Black;

                                e.CurrentWorksheet.Rows[iRow].Cells[iColumn].CellFormat.TopBorderColor = Color.Black;
                                e.CurrentWorksheet.Rows[iRow].Cells[iColumn].CellFormat.BottomBorderColor = Color.Black;

                                //e.CurrentWorksheet.Rows[iRow].Cells[nbColumnsRfc + iColumn].CellFormat.BottomBorderColor = Color.Black;
                                //code changes by seema for evo06 ends
                            }
                            //code changes by seema for evo06 starts
                            //if (iColumn == nbColumnsAction)
                            //    e.CurrentWorksheet.Rows[iRow].Cells[nbColumnsRfc + iColumn].CellFormat.RightBorderColor = Color.Black;
                            //code changes by seema for evo06 ends
                            //code chhanged for evo12 by Koshlendra Pratap Singh on 23/05/2013 start
                            if (iColumn == nbColumnsAction)
                                e.CurrentWorksheet.Rows[iRow].Cells[iColumn + 1].CellFormat.RightBorderColor = Color.Black;
                            //code chhanged for evo12 by Koshlendra Pratap Singh on 23/05/2013 End
                        }
                    }
                    e.CurrentWorksheet.Rows[iRow].Cells[columnToIdentifyRfcOrGlobal].Value = "";
                }
            }
        }

        private void MergeActions(Worksheet worksheet, int rowIndex, int columnOffset, int nbActions, int nbColumns)
        {
            //Merge Columns
            int firstRowToMerge = rowIndex - nbActions;
            int lastRowToMerge = rowIndex - 1;
            //Do not merge * cells
            //Merge les lignes blanches de rfc correspondantes  un nombre d'action >= 2 avec la ligne courante de rfc action = 1
            if (firstRowToMerge < lastRowToMerge)
            {
                for (int iColumn = columnOffset + 1; iColumn <= nbColumns; iColumn++)
                {
                    worksheet.MergedCellsRegions.Add(firstRowToMerge, iColumn, lastRowToMerge, iColumn);
                }
            }
            //Rajouter des bordures noires sur le bas et le haut des groupes d'actions mergs (actions mergs uniquement)
            if (nbActions > 1)
            {
                if (actionLineRfcGlobal)
                {
                    for (int iColumn = 1; iColumn <= nbColumnsGlobalAction; iColumn++)
                    {
                        worksheet.Rows[firstRowToMerge].Cells[nbColumns + iColumn].CellFormat.TopBorderColor = Color.Black;
                        worksheet.Rows[lastRowToMerge].Cells[nbColumns + iColumn].CellFormat.BottomBorderColor = Color.Black;
                    }
                }
                else
                {
                    for (int iColumn = 1; iColumn <= nbColumnsAction; iColumn++)
                    {
                        worksheet.Rows[firstRowToMerge].Cells[nbColumns + iColumn].CellFormat.TopBorderColor = Color.Black;
                        worksheet.Rows[lastRowToMerge].Cells[nbColumns + iColumn].CellFormat.BottomBorderColor = Color.Black;
                    }
                }
            }

            //Rajouter des bordures  gauche et  droite de chaque ligne d'action
            for (int iRow = firstRowToMerge; iRow <= lastRowToMerge; iRow++)
            {
                //worksheet.Rows[iRow].Cells[nbColumns + 1].CellFormat.LeftBorderColor = Color.Black;
                if (actionLineRfcGlobal)
                    worksheet.Rows[iRow].Cells[nbColumns + nbColumnsGlobalAction].CellFormat.RightBorderColor = Color.Black;
                else worksheet.Rows[iRow].Cells[nbColumns + nbColumnsAction].CellFormat.RightBorderColor = Color.Black;
            }
            //recopier la valeur de l'* sur toutes les lignes de rfc supplmentaires et mergs(except la cellule de *) , gnres par le surplus d'actions > 1
            int starColumn = columnOffset;
            for (int iRow = firstRowToMerge + 1; iRow <= lastRowToMerge; iRow++)
            {
                worksheet.Rows[iRow].Cells[starColumn].Value = worksheet.Rows[firstRowToMerge].Cells[starColumn].Value;
                worksheet.Rows[iRow].Cells[starColumn].CellFormat.SetFormatting(worksheet.Rows[firstRowToMerge].Cells[starColumn].CellFormat);
                worksheet.Rows[iRow].Cells[starColumn].CellFormat.TopBorderStyle = CellBorderLineStyle.Thin;
                worksheet.Rows[iRow].Cells[starColumn].CellFormat.TopBorderColor = Color.LightGray;
            }
        }
    }
}
